import React from 'react';
import Button from '@material-ui/core/Button';
import Dialog from '@material-ui/core/Dialog';
import DialogActions from '@material-ui/core/DialogActions';
import DialogContent from '@material-ui/core/DialogContent';
import DialogContentText from '@material-ui/core/DialogContentText';
import DialogTitle from '@material-ui/core/DialogTitle';
import useMediaQuery from '@material-ui/core/useMediaQuery';
import { useTheme } from '@material-ui/core/styles';
import { useIntl } from 'react-intl';
export default function UpdateDialog(_ref) {
  var isUpdateAvailable = _ref.isUpdateAvailable,
      runUpdate = _ref.runUpdate;

  var _React$useState = React.useState(undefined),
      open = _React$useState[0],
      setOpen = _React$useState[1];

  var intl = useIntl();
  var theme = useTheme();
  var fullScreen = useMediaQuery(theme.breakpoints.down('sm'));

  var handleClickOpen = function handleClickOpen() {
    setOpen(true);
  };

  var handleClose = function handleClose() {
    setOpen(false);
  };

  var handleUpdate = function handleUpdate() {
    handleClose();
    runUpdate();
  };

  return /*#__PURE__*/React.createElement(Dialog, {
    fullScreen: fullScreen,
    open: isUpdateAvailable && open === undefined,
    onClose: handleClose,
    "aria-labelledby": "update-dialog-title"
  }, /*#__PURE__*/React.createElement(DialogTitle, {
    id: "update-dialog-title"
  }, intl.formatMessage({
    id: 'update_dialog_title',
    defaultMessage: 'Update available!'
  })), /*#__PURE__*/React.createElement(DialogContent, null, /*#__PURE__*/React.createElement(DialogContentText, null, intl.formatMessage({
    id: 'update_dialog_message',
    defaultMessage: 'Make sure to save all data before updating. The update could cause losing unsaved data. You can also make the update later.'
  }))), /*#__PURE__*/React.createElement(DialogActions, null, /*#__PURE__*/React.createElement(Button, {
    autoFocus: true,
    onClick: handleClose,
    color: "primary"
  }, intl.formatMessage({
    id: 'update_dialog_later',
    defaultMessage: 'Later'
  })), /*#__PURE__*/React.createElement(Button, {
    onClick: handleUpdate,
    color: "secondary",
    autoFocus: true
  }, intl.formatMessage({
    id: 'update_dialog_update',
    defaultMessage: 'Update'
  }))));
}