import { lazy } from 'react';
import Loading from '../components/Loading/Loading';
var config = {
  containers: {
    AppContainer: lazy(function () {
      return import('../containers/AppContainer/AppContainer');
    }),
    LayoutContainer: lazy(function () {
      return import('../containers/LayoutContainer/LayoutContainer');
    })
  },
  components: {
    Loading,
    Menu: lazy(function () {
      return import('../containers/Menu/Menu');
    })
  },
  pwa: {
    useiOSPWAPrompt: true,
    iOSPWAPromptProps: {}
  },
  menu: {
    width: 240,
    offlineIndicatorHeight: 12,
    useMini: true,
    MenuHeader: lazy(function () {
      return import('../components/MenuHeader/MenuHeader');
    })
  },
  pages: {
    LandingPage: lazy(function () {
      return import('../pages/LandingPage/LandingPage');
    }),
    PageNotFound: lazy(function () {
      return import('../pages/PageNotFound/PageNotFound');
    })
  },
  update: {
    checkInterval: 3000,
    repeatInterval: 300000
  }
};
export default config;