import React, { Fragment, useEffect } from 'react';
import { useConfig } from 'base-shell/lib/providers/Config';
import { useSnackbar } from 'notistack';
import { useIntl } from 'react-intl';
import Button from '@material-ui/core/Button';

var runUpdate = function runUpdate() {
  window.update && window.update();
};

export default function (_ref) {
  var children = _ref.children;
  var intl = useIntl();

  var _useConfig = useConfig(),
      appConfig = _useConfig.appConfig;

  var _useSnackbar = useSnackbar(),
      enqueueSnackbar = _useSnackbar.enqueueSnackbar,
      closeSnackbar = _useSnackbar.closeSnackbar;

  var _ref2 = appConfig || {},
      update = _ref2.update;

  var _ref3 = update || {},
      _ref3$checkInterval = _ref3.checkInterval,
      checkInterval = _ref3$checkInterval === void 0 ? 3000 : _ref3$checkInterval,
      _ref3$repeatInterval = _ref3.repeatInterval,
      repeatInterval = _ref3$repeatInterval === void 0 ? 300000 : _ref3$repeatInterval;

  var action = function action(key) {
    return /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(Button, {
      variant: "contained",
      style: {
        margin: 8
      },
      onClick: function onClick() {
        closeSnackbar(key);
        runUpdate();
      }
    }, intl.formatMessage({
      id: 'udpate',
      defaultMessage: 'Update'
    })), /*#__PURE__*/React.createElement(Button, {
      color: "secondary",
      onClick: function onClick() {
        setTimeout(checkUpdate, repeatInterval);
        closeSnackbar(key);
      }
    }, intl.formatMessage({
      id: 'later',
      defaultMessage: 'Later'
    })));
  };

  var showUpdateToast = function showUpdateToast() {
    enqueueSnackbar(intl.formatMessage({
      id: 'update_available',
      defaultMessage: 'Update available!'
    }), {
      persist: true,
      action,
      preventDuplicate: true,
      anchorOrigin: {
        vertical: 'top',
        horizontal: 'center'
      }
    });
  };

  var checkUpdate = function checkUpdate() {
    if (window.update) {
      showUpdateToast();
    } else {
      setTimeout(checkUpdate, checkInterval);
    }
  };

  useEffect(checkUpdate, [checkUpdate]);
  return /*#__PURE__*/React.createElement(Fragment, null, children);
}