function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import PropTypes from 'prop-types';
import React, { useState, Fragment } from 'react';
import Context from './Context';
import QuestionDialog from 'material-ui-shell/lib/components/QuestionDialog/QuestionDialog';

var Provider = function Provider(_ref) {
  var children = _ref.children;

  var _useState = useState({
    isOpen: false
  }),
      state = _useState[0],
      setState = _useState[1];

  var _useState2 = useState(false),
      isProcessing = _useState2[0],
      setIsProcessing = _useState2[1];

  var openDialog = function openDialog(props) {
    setState(_extends({
      isOpen: true
    }, props));
  };

  var closeDialog = function closeDialog() {
    setState({
      isOpen: false
    });
  };

  var setProcessing = function setProcessing(isProcessing) {
    setIsProcessing(isProcessing);
  };

  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      openDialog,
      closeDialog,
      setProcessing
    }
  }, /*#__PURE__*/React.createElement(Fragment, null, children, /*#__PURE__*/React.createElement(QuestionDialog, _extends({
    handleClose: closeDialog,
    isProcessing: isProcessing
  }, state))));
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any
} : {};
export default Provider;