function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import PropTypes from 'prop-types';
import React, { useEffect, useReducer } from 'react';
import Context from './Context';
import reducer from './store/reducer';
import { addFilterQuery as _addFilterQuery, clearFilter as _clearFilter, closeFilter as _closeFilter, editFilterQuery as _editFilterQuery, openFilter as _openFilter, removeFilterQuery as _removeFilterQuery, setFilterSortField as _setFilterSortField, setFilterSortOrientation as _setFilterSortOrientation, setSearch as _setSearch } from './store/actions';
import { getList as _getList, getField as _getField } from './store/selectors';

function getInitState(persistKey) {
  var persistedValues = {};

  try {
    persistedValues = JSON.parse(localStorage.getItem(persistKey)) || {};
  } catch (error) {
    console.warn(error);
  }

  return persistedValues;
}

var Provider = function Provider(_ref) {
  var children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'mui_filter' : _ref$persistKey;

  var _useReducer = useReducer(reducer, getInitState(persistKey)),
      state = _useReducer[0],
      dispatch = _useReducer[1];

  useEffect(function () {
    try {
      localStorage.setItem(persistKey, JSON.stringify(state));
    } catch (error) {
      console.warn(error);
    }
  }, [state, persistKey]);
  var props = {
    openFilter: function openFilter(name) {
      return dispatch(_openFilter(name));
    },
    closeFilter: function closeFilter(name) {
      return dispatch(_closeFilter(name));
    },
    clearFilter: function clearFilter(name) {
      return dispatch(_clearFilter(name));
    },
    setSearch: function setSearch(name, search) {
      return dispatch(_setSearch(name, search));
    },
    setFilterSortField: function setFilterSortField(name, sortField) {
      return dispatch(_setFilterSortField(name, sortField));
    },
    setFilterSortOrientation: function setFilterSortOrientation(name, sortOrientation) {
      return dispatch(_setFilterSortOrientation(name, sortOrientation));
    },
    addFilterQuery: function addFilterQuery(name, query) {
      return dispatch(_addFilterQuery(name, query));
    },
    removeFilterQuery: function removeFilterQuery(name, index) {
      return dispatch(_removeFilterQuery(name, index));
    },
    editFilterQuery: function editFilterQuery(name, index, query) {
      return dispatch(_editFilterQuery(name, index, query));
    },
    getList: function getList(name, list, fields) {
      return _getList(state[name], list, fields);
    },
    isFilterOpen: function isFilterOpen(name) {
      return state[name] ? !!state[name].isOpen : false;
    },
    getFilterQueries: function getFilterQueries(name) {
      return state[name] && state[name].queries ? state[name].queries : [];
    },
    getFilter: function getFilter(name) {
      return state[name] ? state[name] : {};
    },
    getField: function getField(fieldName, fields) {
      return _getField(fieldName, fields);
    }
  };
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: _extends({}, props)
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any,
  firebaseApp: PropTypes.any
} : {};
export default Provider;