import PropTypes from 'prop-types';
import React, { useState, useEffect } from 'react';
import Context from './Context';
import useMediaQuery from '@material-ui/core/useMediaQuery';

var Provider = function Provider(_ref) {
  var appConfig = _ref.appConfig,
      children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'menu' : _ref$persistKey;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      _ref3$useMini = _ref3.useMini,
      useMini = _ref3$useMini === void 0 ? true : _ref3$useMini;

  var _useState = useState(true),
      isDesktopOpen = _useState[0],
      setDesktopOpen = _useState[1];

  var _useState2 = useState(false),
      isMobileOpen = _useState2[0],
      setMobileOpen = _useState2[1];

  var _useState3 = useState(useMini),
      useMiniMode = _useState3[0],
      setMiniMode = _useState3[1];

  var _useState4 = useState(false),
      isAuthMenuOpen = _useState4[0],
      setAuthMenuOpen = _useState4[1];

  var _useState5 = useState(false),
      isMini = _useState5[0],
      setMini = _useState5[1];

  var isDesktop = useMediaQuery('(min-width:600px)');
  var isDesktopKey = persistKey + ":isDesktopOpen";
  var isMiniKey = persistKey + ":isMini";
  var isUseMiniModeKey = persistKey + ":isUseMiniModeKey";
  useEffect(function () {
    var persistDesktopOpen = localStorage.getItem(isDesktopKey);
    var persistMini = localStorage.getItem(isMiniKey);
    var persistMiniMode = localStorage.getItem(isUseMiniModeKey);

    if (persistDesktopOpen) {
      setDesktopOpen(persistDesktopOpen === 'true');
    }

    if (persistMini) {
      setMini(persistMini === 'true');
    }

    if (persistMiniMode) {
      setMiniMode(persistMiniMode === 'true');
    }
  }, [isDesktopKey, isMiniKey, isUseMiniModeKey]);
  useEffect(function () {
    try {
      localStorage.setItem(isDesktopKey, JSON.stringify(isDesktopOpen));
    } catch (error) {
      console.warn(error);
    }
  }, [isDesktopOpen, isDesktopKey]);
  useEffect(function () {
    try {
      localStorage.setItem(isMiniKey, JSON.stringify(isMini));
    } catch (error) {
      console.warn(error);
    }
  }, [isMini, isMiniKey]);
  useEffect(function () {
    try {
      localStorage.setItem(isUseMiniModeKey, JSON.stringify(useMiniMode));

      if (!useMiniMode) {
        setMini(useMiniMode);
      }
    } catch (error) {
      console.warn(error);
    }
  }, [useMiniMode, isUseMiniModeKey]);
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      isDesktop,
      isDesktopOpen,
      isMobileOpen,
      setDesktopOpen,
      setMobileOpen,
      isAuthMenuOpen,
      setAuthMenuOpen,
      isMini,
      setMini,
      useMiniMode,
      setMiniMode
    }
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any
} : {};
export default Provider;