function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import PropTypes from 'prop-types';
import React, { useReducer } from 'react';
import Context from './Context';

function reducer(state, action) {
  var type = action.type,
      name = action.name,
      offset = action.offset;

  switch (type) {
    case 'SET_OFFSET':
      return _extends(_extends({}, state), {}, {
        [name]: offset
      });

    default:
      throw new Error();
  }
}

var Provider = function Provider(_ref) {
  var children = _ref.children;

  var _useReducer = useReducer(reducer, {}),
      state = _useReducer[0],
      dispatch = _useReducer[1];

  var setOffset = function setOffset(name, offset) {
    dispatch({
      type: 'SET_OFFSET',
      name,
      offset
    });
  };

  var getOffset = function getOffset(name) {
    return state[name] || 0;
  };

  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      setOffset,
      getOffset
    }
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any
} : {};
export default Provider;