"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Avatar = _interopRequireDefault(require("@material-ui/core/Avatar"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _ChromeReaderMode = _interopRequireDefault(require("@material-ui/icons/ChromeReaderMode"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemAvatar = _interopRequireDefault(require("@material-ui/core/ListItemAvatar"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@material-ui/core/ListItemSecondaryAction"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _Person = _interopRequireDefault(require("@material-ui/icons/Person"));

var _Auth = require("base-shell/lib/providers/Auth");

var _Menu = require("material-ui-shell/lib/providers/Menu");

var _Theme = require("material-ui-shell/lib/providers/Theme");

var _styles = require("@material-ui/core/styles");

var _clsx = _interopRequireDefault(require("clsx"));

var _ArrowDropDown = _interopRequireDefault(require("@material-ui/icons/ArrowDropDown"));

var _ArrowDropUp = _interopRequireDefault(require("@material-ui/icons/ArrowDropUp"));

var _Brightness = _interopRequireDefault(require("@material-ui/icons/Brightness4"));

var _BrightnessHigh = _interopRequireDefault(require("@material-ui/icons/BrightnessHigh"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    paper: {
      backgroundColor: theme.palette.primary.dark,
      margin: 0,
      padding: 0
    },
    listItem: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    icon: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    toolbar: _extends({
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-end',
      padding: theme.spacing(0, 2)
    }, theme.mixins.toolbar)
  };
});

var MenuHeader = function MenuHeader() {
  var theme = (0, _styles.useTheme)();

  var _useAuth = (0, _Auth.useAuth)(),
      auth = _useAuth.auth;

  var _useAppTheme = (0, _Theme.useTheme)(),
      type = _useAppTheme.type,
      setType = _useAppTheme.setType;

  var authData = auth;
  var classes = useStyles();

  var _useMenu = (0, _Menu.useMenu)(),
      isDesktop = _useMenu.isDesktop,
      isDesktopOpen = _useMenu.isDesktopOpen,
      setDesktopOpen = _useMenu.setDesktopOpen,
      isMini = _useMenu.isMini,
      setMini = _useMenu.setMini,
      isAuthMenuOpen = _useMenu.isAuthMenuOpen,
      setAuthMenuOpen = _useMenu.setAuthMenuOpen,
      useMiniMode = _useMenu.useMiniMode;

  var isAuthenticated = auth.isAuthenticated;
  return /*#__PURE__*/_react.default.createElement(_Paper.default, {
    square: true,
    className: classes.paper
  }, isMini && isAuthenticated && /*#__PURE__*/_react.default.createElement("div", {
    className: classes.toolbar
  }), /*#__PURE__*/_react.default.createElement(_List.default, {
    className: (0, _clsx.default)(!isAuthenticated && classes.toolbar)
  }, !isMini && /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    className: classes.listItem
  }, isAuthenticated && !isMini && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: authData.photoURL,
    alt: "user"
  })), !authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, null, authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/_react.default.createElement(_Person.default, null)))), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, null, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      setType(type === 'light' ? 'dark' : 'light');
    }
  }, type === 'light' && /*#__PURE__*/_react.default.createElement(_Brightness.default, {
    classes: {
      root: classes.icon
    }
  }), type === 'dark' && /*#__PURE__*/_react.default.createElement(_BrightnessHigh.default, {
    classes: {
      root: classes.icon
    }
  })), isDesktop && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, useMiniMode && /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      setMini(true);
      setDesktopOpen(false);
    }
  }, /*#__PURE__*/_react.default.createElement(_ChromeReaderMode.default, {
    classes: {
      root: classes.icon
    }
  })), /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    onClick: function onClick() {
      setDesktopOpen(false);
    }
  }, theme.direction === 'rtl' && /*#__PURE__*/_react.default.createElement(_ChevronRight.default, {
    classes: {
      root: classes.icon
    }
  }), theme.direction !== 'rtl' && /*#__PURE__*/_react.default.createElement(_ChevronLeft.default, {
    classes: {
      root: classes.icon
    }
  })), ' '))), isAuthenticated && /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, !isDesktopOpen && isDesktop && authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, null, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: authData.photoURL,
    alt: "person" //style={{ marginLeft: 0, marginTop: 0 }}

  })), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
    classes: {
      primary: classes.listItem,
      secondary: classes.listItem
    },
    style: {
      marginLeft: !isDesktopOpen && isDesktop && authData.photoURL ? 7 : undefined
    },
    primary: authData.displayName,
    secondary: authData.email
  }), isDesktopOpen && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, null, isAuthMenuOpen && /*#__PURE__*/_react.default.createElement(_ArrowDropUp.default, {
    classes: {
      root: classes.icon
    }
  }), !isAuthMenuOpen && /*#__PURE__*/_react.default.createElement(_ArrowDropDown.default, {
    classes: {
      root: classes.icon
    }
  }))))));
};

var _default = MenuHeader;
exports.default = _default;
module.exports = exports.default;